.286

clr=256                         ;code d'effacement de l'alphabet
eof=257                         ;code de fin de fichier
w equ word ptr
b equ byte ptr

data segment public
  extrn gifname:dataptr         ;Nom du fichier Gif, avec ".gif" + db 0
  extrn vscreen:dword           ;pointe sur la mmoire de destination
  extrn palette:dataptr         ;palette de destination
  extrn vram_pos:word           ;position  l'intrieur de la mmoire d'cran
  extrn rest:word               ;nbre de codes restant  copier
  extrn numerr:word;            ;indicateur d'erreur

  handle     dw 0               ;handle DOS pour fichier Gif
  buff       db 768 dup (0)     ;buffer des donnes lues      
  buffInd     dw 0              ;pointeur  l'intrieur de ce buffer
  abStack    db 1281 dup (0)    ;pile de dcodage            
  ab_prfx    dw 4096 dup (0)    ;alphabet, prfixe 
  ab_suffx    dw 4096 dup (0)   ;alphabet, suffixe
  free      dw 0                ;position libre dans l'alphabet
  nbbit    dw 0                 ;nombre de bits dans un code
  max        dw 0       ;nombre maximum d'entres dans un alphabet  nbbit
  stackp    dw 0                ;pointeur dans la pile de l'alphabet
  restbits  dw 0                ;nombre de bits  lire      
  restbyte  dw 0                ;nombre d'octets disponibles dans le buffer
  casspecial dw 0               ;mmoire pour le cas spcial
  act_code  dw 0                ;code trait 
  old_code  dw 0                ;code prcdent     
  readbyt   dw 0                ;code en cours de lecture               
  lbyte      dw 0               ;dernier code lu
data ends

extrn p13_2_modex:far           ;utilis en cas de dpassement du segment

code segment public
assume cs:code,ds:data

public readgif
GifRead proc pascal n:word
;lit n octets dans le fichier        
  mov ax,03f00h                 ;fonction 3fh de l'interruption 21h   
  mov bx,handle                 ;charge le handle
  mov cx,n                      ; et le nombre d'octets  lire  
  lea dx,buff                    ;pointe sur le buffer de destination
  int 21h                       ;excute l'interruption
  ret
gifread endp

GifOpen proc pascal
;ouvre le fichier Gif pour y accder en lecture
  mov ax,03d00h                 ;fonction 3dh: ouvrir
  lea dx,gifname + 1  ;pointe sur le nom (saute l'octet qui mmorise la taille)
  int 21h                       ;excute l'interruption
  mov handle,ax                 ;sauvegarde le handle
  ret
gifopen endp

GifClose proc pascal
;ferme le fichier Gif
  mov ax,03e00h                 ;fonction 3eh: fermer   
  mov bx,handle                 ;charge le handle
  int 21h                       ;excute l'interruption
  ret
gifclose endp

GifSeek proc pascal ofs:dword
;positionne le pointeur du fichier 
  mov ax,04200h                 ;fonction 42h,
  mov bx,w handle          ;sous-fonction 0: Seek relatif au dbut du fichier
  mov cx,word ptr ofs + 2       ;charge l'offset
  mov dx,word ptr ofs
  int 21h                       ;excute l'interruption
  ret
Endp
ShiftPal proc pascal
;adapte la palette 24 bits au format VGA (18 bits)            
  mov ax,ds             ;segment de donnes pour tables source et destination 
  mov es,ax
  mov si,offset buff            ;lecture dans le buffer de donnes
  lea di,palette                ;criture dans la palette de destination
  mov cx,768d                   ;traite 786 octets
@l1:
  lodsb                         ;lit un octet
  shr al,2                      ;le convertit
  stosb                         ;et l'enregistre
  loop @l1
  ret
Endp
FillBuff proc pascal
;lit tout un bloc du fichier en Buf
  call gifread pascal,1         ;lit un octet
  mov al,b buff[0]               ;transfre la taille en al 
  xor ah,ah
  mov w restbyte,ax             ;et la mmorise en restbyte 
  call gifread pascal, ax       ;lit les octets
  ret
Endp

GetPhysByte proc pascal
;lit un octet dans le buffer
  push bx                       ;bx prserv pour l'appelant
  cmp w restbyte,0              ;plus de donnes dans le buffer ?
  ja @yadurab
  pusha                         ;remplit  nouveau le buffer 
  call fillbuff
  popa
  mov w buffInd,0               ;rinitialise le pointeur 
@yadurab:                       ;il y a des donnes dans le buffer
  mov bx,w buffInd              ;charge le pointeur
  mov al,b buff[bx]             ;lit un octet
  inc w buffInd                 ;dplace le pointeur 
  pop bx                        ;c'est tout 
  ret
Endp

GetLogByte proc pascal
;lit un code dans le buffer en exploitant GetPhysByte
  push si                       ;registre "si" prserv pour l'appelant
  mov ax,w nbbit                ;lit la taille en bits du code
  mov si,ax                     ;et la sauvegarde 
  mov dx,w restbits             ;dcale lbyte de 8-restbits vers la droite
  mov cx,8
  sub cx,dx                     ;calcule la diffrence
  mov ax,w lByte
  shr ax,cl                     ;et lance le dcalage 
  mov w act_code,ax             ;sauve le code 
  sub si,dx                     ;restbits dj lus -> soustraire
 @nextbyte:
  call getphysbyte              ;lit un nouvel octet
  xor ah,ah
  mov w lByte,ax                ;le met en lByte pour le prochain code
  dec w restbyte                ;octet trait

  mov bx,1                      ;masque les bits restants dans l'octet
  mov cx,si                     ;fixe le nombre de bits
  shl bx,cl                     ;dcale 1 du nombre de bits
  dec bx                        ;et dcrmente
  and ax,bx                     ;masque le code 

  mov cx,dx                     ;effectue le dcalage recherch
  shl ax,cl                     ;de restbits vers la gauche 
  add w act_code,ax             ;ajoute le rsultat

  sbb dx,w nbbit                ;diminue le nombre restbits 
  add dx,8                      ;de ce qui dpasse 8 bits
  jns @positif
  add dx,8
@positif:
  sub si,8                      ;jusqu' 8 bits cherchs -> soustraire
  jle @fini                     ;<= 0 -> tout est fini
  add dx,w nbbit         ;sinon augmente restbits du nombre de bits manquants
  sub dx,8
  jmp @nextbyte                 ;et on continue
@fini:
  mov w restbits,dx   ;sauve le nombre de bits restants pour le prochain appel
  mov ax,w act_code   ;et charge ax
  pop si
  ret
Endp

ReadGif proc pascal
;lit en vscreen un fichier Gif appel gifname,
;en cas de dpassement, stockage en mmoire d'cran
  push ds                       ;sauvegarde ds
  call GifOpen                  ;ouvre le fichier
  jnc ok                        ;erreur ?
  mov numerr,1                  ;la signaler et conclure
  pop ds
  ret

ok:
  call gifseek pascal, 0,13d    ;saute les 13 premiers octets
  push 768d                     ;lit les 768 octets de la palette
  call gifread
  call shiftpal                 ;et l'enregistre avec conversion
  call gifread pascal,1         ;passe un octet

@extloop:                       ;laisse tomber les blocs d'extension
  cmp w buff[0],21h              ;encore un bloc d'extension ? ?
  jne @noext                    ;non, on continue
    call gifread pascal,2       ;les deux premiers octets...
    mov al,b buff[1]             ;...donnent la longueur du bloc...
    inc al                      ;...si on ajoute 1 
    xor ah,ah
    call gifread pascal, ax     ;on passe par dessus
  jmp @extloop

@noext:
  call gifread pascal, 10d      ;lit le reste de l'IDB
  test b buff[8],128             ;une palette locale  ?
  je @noloc                     ;non on poursuit 
    push 768                    ;lit la palette 
    call gifread
    call shiftpal               ;et la convertit

@noloc:
  les di,dword ptr vscreen      ;charge l'adresse de destination

  mov w lbyte,0                 ;dernier code lu 0
  mov w free,258                ;premire entre libre 258
  mov w nbbit,9                 ;nb de bits d'un code = 9 
  mov w max,511                 ;donc maximum d'entres = 511
  mov w stackp,0                ;pointeur sur dbut
  mov w restbits,0              ;pas de bits restants
  mov w restbyte,0              ;rien  chercher
@mainloop:                      ;boucle pour chaque code
  call getlogByte               ;lit un code
  cmp ax,eof                    ;signature fin de fichier ?
  jne @no_abandon
  jmp @abandon                  ;oui, abandonne
@no_abandon:
  cmp ax,clr                    ;code clr  ?
  jne @no_clear
  jmp @clear                    ;oui efface l'alphabet
@no_clear:
  mov w readbyt,ax              ;sauve le code actuel
  cmp ax,w free                 ;est-il dj dans l'alphabet ? (<free)
  jb @code_in_ab                ;oui, passe au traitement 
  mov ax,w old_code             ;non, donc cas spcial, transmettre 
  mov w act_code,ax             ;au traitement la dernire chane
  mov bx,w stackp
  mov cx,w casspecial    ;et accrocher le premier caractre (toujours concret)
  mov w abstack[bx],cx          ;gre la pile
  inc w stackp                  ;en consquence
@code_in_ab:                    ;code disponible dans l'alphabet :
  cmp ax,clr                    ;< code clr ?
  jb @concret                   ;oui, caractre concret
@fillstack_loop:                ;sinon passe au dcodage
  mov bx,w act_code             ;le code est un pointeur dans l'alphabet
  shl bx,1                      ;Word Array (!)
  push bx
  mov ax,w ab_suffx[bx]         ;cherche le suffixe, qui est concret
  mov bx,w stackp               ;le place sur la pile
  shl bx,1                      ;considre comme Word Array
  mov w abstack[bx],ax
  inc w stackp
  pop bx
  mov ax,w ab_prfx[bx]          ;cherche le prfixe
  mov w act_code,ax             ;le prend comme code courant
  cmp ax,clr;> code clr 
  ja @fillstack_loop            ;poursuit le dcodage
@concret:                       ;plus que des caractres concrets sur la pile
  mov bx,w stackp               ;empile le dernier code
  shl bx,1                      ;comme Word Array
  mov w abstack[bx],ax
  mov w casspecial,ax           ;en prend note aussi pour le cas spcial 
  inc w stackp                  ;fait progresser le pointeur
  mov bx,w stackp               ;prpare la lecture de la pile
  dec bx                        ;dcrmente le pointeur
  shl bx,1                      ;sur Word Array 
@readstack_loop:                ;traite la pile
  mov ax,w abstack[bx]          ;prend un caractre
  stosb                         ;et l'crit dans la mmoire de  destination

  cmp di,0                      ;dpasse-t-on le segment ?
  jne @noovl1
  call p13_2_modex pascal,vram_pos,16384d
  add vram_pos,16384d           ;exploite la mmoire d'cran
  les di,dword ptr vscreen      ;nouvelle position en mmoire VGA

@noovl1:
  dec bx                        ;pointeur de pile sur l'lment suivant
  dec bx
  jns @readstack_loop           ;fini ? non on poursuit
  mov w stackp,0                ;rinitialise le pointeur de pile
  mov bx,w free                 ;met  jour l'alphabet
  shl bx,1                      ; la position "free" 
  mov ax,w old_code             ;crit le dernier code dans prfixe
  mov w ab_prfx[bx],ax
  mov ax,w act_code             ;et le code courant dans suffixe
  mov w ab_suffx[bx],ax
  mov ax,w readbyt              ;le code  lu est le plus rcent
  mov w old_code,ax
  inc w free           ;met  jour la dernire position libre dans l'alphabet 
  mov ax,w free
  cmp ax,w max                  ;dj satur ??
  ja @no_mainloop
  jmp @mainloop                 ;non, on continue
@no_mainloop:
  cmp b nbbit,12                ;nombre de bits dj gal  12 ?
  jb @no_mainloop2
  jmp @mainloop                 ;oui, alors on recommence simplement
@no_mainloop2:
  inc w nbbit                   ;sinon on l'augmente
  mov cl,b nbbit                ;nouveau maximum d'entres
  mov ax,1                      ;1 dcal de nbbit vers la gauche
  shl ax,cl
  dec ax                        ;puis dcrment
  mov w max,ax                  ;enregistre le maximum 
  jmp @mainloop                 ;revient  la boucle principale
@clear:                         ;rinitialise l'alphabet:
  mov w nbbit,9                 ;nbbit reprend la valeur de dpart
  mov w max,511                 ;le maximum d'entres est 511
  mov w free,258                ;premire place libre = 258
  call getlogbyte               ;lit le code suivant
  mov w casspecial,ax           ;le note pour le cas spcial
  mov w old_code,ax             ;et comme ancien code
  stosb                         ;passe directement en mmoire car concret

  cmp di,0                      ;dpassement de segment ?
  jne @noovl2
  call p13_2_modex pascal,vram_pos,16384d
  add vram_pos,16384d           ;stockage dans la mmoire d'cran
  les di,dword ptr vscreen      ;avance le pointeur en mmoire VGA

@noovl2:
  jmp @mainloop                 ;retour  la boucle principale
@abandon:                       ;abandon par code Eof
  call gifclose                 ;ferme le fichier
  mov rest,di                   ;mmorise le nombre de codes restant  copier
  pop ds                        ;et clture
  ret
Endp

code ends
end
