Unit Sprites;

Interface

Type SpriteTyp=Record  {structure d'un bloc de donnes dcrivant un sprite}
  Adr:Pointer;         {pointe sur les donnes graphiques }
  dtx,dty:Word;        {largeur et hauteur en pixels }
  px,py,               {position courante, facultatif *}
  sx,sy:Integer;       {vitesse courante, facultatif *}
End;
{* : facultatif veut dire que les routines GetSprite et PutSprite n'utilisent
pas ces variables qui ne servent qu' faciliter une gestion par le programme
principal }

Procedure GetSprite(Ofs,dtx,dty:Word;var dSprite:SpriteTyp);
{lit un sprite de largeur dtx, de hauteur dty,  l'offset ofs de vscreen,
 dSprite est l'enregistrement qui va mmoriser le sprite}

Procedure PutSprite(pg_ofs,x,y:Integer;sSprite:spritetyp);
{copie un sprite de la mmoire centrale (situation et taille dans sSprite)
 vers la mmoire d'cran en page pg et coordonnes (x,y}


Implementation
Uses ModeXLib;

Var i:Word;

Procedure GetSprite;
Var ppp:Array[0..3] of Byte; {table avec le nombre de pixels  copier par plan }
    Skip:word;               {nombre d'octets  sauter}
    Plane_Count:Word;        {nombre de plans dj copis }
Begin
  GetMem(dSprite.adr,dtx*dty); {alloue de la mmoire }
  dSprite.dtx:=dtx;            {prend note de la largeur et de la hauteur }
  dSprite.dty:=dty;            {dans l'enregistrement du sprite }

  i:=dtx shr 2;                {nombre de groupes de 4 octets}
  ppp[0]:=i;ppp[1]:=i;         {correspond au nombre minimum d'octets  copier }
  ppp[2]:=i;ppp[3]:=i;
  For i:=1 to dtx and 3 do   {mmorise en ppp les pixels restants  }
    Inc(ppp[(i-1) and 3]);   {ajoute les pixels en commenant par le plan de dbut}
  Plane_Count:=4;            {copie 4 plans }
asm
  push ds
  mov di,word ptr dSprite  {charge d'abord un pointeur sur le bloc de donnes}
  les di,[di]              {es:di va pointer sur les donnes graphiques}
  lea bx,ppp               {bx rfrence le tableau ppp}

  lds si,vscreen      {charge un pointeur sur l'cran}
   add Ofs,si         {ajoute l'offset des donnes du sprite proprement dites}
@lcopy_plane:         {boucle des plans}
  mov si,ofs          {si reoit l'adresse de dbut des donnes du sprite }
  mov dx,dty          {le compteur d'ordonnes reoit le nombre de lignes}

  xor ah,ah           {efface ah}
  mov al,ss:[bx]      {charge en al l'lment courant de ppp}
  shl ax,2            {on dplace des groupes de 4 octets}
  sub ax,320          {calcule la diffrence par rapport  320}
  neg ax              {convertit ax-320 en 320-ax }
  mov skip,ax         {sauvegarde le rsultat en Skip }

@lcopy_y:             {boucle des lignes }
  mov cl,ss:[bx]      {tire la largeur du tableau ppp }
@lcopy_x:             {boucle des pixels }
  movsb               {copie un octet }
  add si,3            {point suivant dans le mme plan }
  dec cl              {copie tous les points de la ligne }
  jne @lcopy_x

  add si,skip         {passe  la ligne suivante }
  dec dx              {copie toutes les lignes }
  jne @lcopy_y

  inc bx              {pointe sur l'lment suivant de ppp }
  inc ofs             {se positionne sur le nouveau dbut de plan }
  dec plane_count     {copie tous les plans }
  jne @lcopy_plane

  pop ds
End;
End;

Procedure PutSprite;
var plane_count,              {nombre de plans dj copis }
    masqueplan:Byte;          {masque Write-Plane dans le registre 2 du TS }
    Skip,                     {nombre d'octets  sauter }
    ofs,                      {offset courant dans la mmoire d'cran }
    plane,                    {numro du plan courant }
    Largeur,                  {largeur en octets  copier dans une ligne }
    dty:Word;                 {hauteur }
    source:Pointer;     {pointe sur les donnes graphiques lorsque ds varie }
    clip_lt, clip_rt:integer; {nombre de pixels restant  droite et  gauche }
    clipact_lt,               {nombre d'octets restants }
    clipact_rt,               {pour le plan courant }
    clip_dn,clip_up:Word;     {nombre de lignes restant en haut et en bas }

    ppp:Array[0..3] of Byte;  {nombre de pixels par plan }
    cpp:Array[0..3] of Byte;  {nombre d'octets restants par plan }

Begin
  if (x > 319) or               {pas de dessin }
  (x+sSprite.dtx < 0) or        {sprite en dehors de l'cran ?}
  (y > 199) or
  (y+sSprite.dty < 0) then exit;
  clip_rt:=0;                   {normalement pas de clipping }
  clip_lt:=0;                   {-> toutes les variables de clipping  0 }
  clip_dn:=0;
  clip_up:=0;
  clipact_rt:=0;
  clipact_lt:=0;
   with sSprite do begin
    if y+dty > 200 then begin  {premier cas de clipping : en bas}
      clip_dn:=(y+dty-200);    {nombre de lignes restantes }
      dty:=200-y;              {rduit la hauteur du sprite }
    End;
    if y<0 then begin          {deuxime cas de clipping: en haut}
      clip_up:=-y;             {nombre de lignes restantes }
      dty:=dty+y;              {rduit la hauteur du spr }
      y:=0;          {ordonne de dpart nulle, au bord suprieur de l'cran }
    End;
    if x+dtx > 320 then begin   {troisime cas de clipping :  droite }
      clip_rt:=x+dtx-320;       {pixels restants }
      dtx:=320-x;               {rduit la largeur }
    End;
    if x<0 then begin           {quatrime cas de clipping :  gauche }
      clip_lt:=-x;              { nombre de pixels restants }
      plane:=4-(clip_lt mod 4); {nouveau plan de dbut pour la colonne 0 }
      plane:=plane and 3;       {ramne  l'intervalle 0..3 }
      ofs:=pg_ofs+80*y+((x+1) div 4) - 1;  {Ofs sur groupe de 4 octets }
      x:=0;                                {colonne de dbut }
    End Else Begin                         { droite pas de clipping?}
      plane:=x mod 4;                    {alors calcul conventionnel du plan }
      ofs:=pg_ofs+80*y+(x div 4);        {et de l'offset }
    End;
  End;
  Source:=sSprite.adr;         {mmorise pointeur sur les donnes graphiques }
  dty:=sSprite.dty;            {et hauteur dans variables locales }
  Largeur:=0;                  {initialise largeur et Skip }
  Skip:=0;

  i:=sSprite.dtx shr 2;      {nombre de groupes de 4 octets complets}
  ppp[0]:=i;ppp[1]:=i;       {correspond au nombre minimum d'octets  copier }
  ppp[2]:=i;ppp[3]:=i;
  For i:=1 to sSprite.dtx and 3 do{mmorise en ppp les pixels restants }
    Inc(ppp[(plane+i - 1) and 3]);{ajoute les pixels en commenant par le plan de dbut }

  i:=(clip_lt+clip_rt) shr 2;
  cpp[0]:=i;cpp[1]:=i;          {valeurs par dfaut du clipping}
  cpp[2]:=i;cpp[3]:=i;
  For i:=1 to clip_rt and 3 do  {si clipping  droite }
    Inc(cpp[i-1]);              {enregistre le nombre dans les plans }
  For i:=1 to clip_lt and 3 do  {si clipping  gauche }
    Inc(cpp[4-i]);              {enregistre le nombre dans les plans }

asm
  mov dx,3ceh                   {met le registre 5 du GDC (GDC Mode)}
  mov ax,4005h                  {en mode Write 0 }
  out dx,ax
  push ds                       {sauve ds}
  mov ax,0a000h                 {charge le segment de destination (VGA) }
  mov es,ax

  lds si,source       {ds:si va pointer sur la source (donnes graphiques ) }
  mov cx,plane        {masque de plan de dpart }
  mov ax,1            {dcale le bit 0 vers la gauche }
  shl ax,cl
  mov masqueplan,al           {sauve le masque }
  shl al,4                    {le reporte dans le quartet suprieur }
  or masqueplan,al
  mov plane_count,4          {4 plans  copier }
@lplane:                     {boucle des plans }
  mov cl,byte ptr plane      {charge le plan courant }
  mov di,cx                  {en di}
  mov cl,byte ptr ppp[di]    {charge le nombre ppp corrrespondant en cx }
  mov byte ptr Largeur,cl    {recalcule Skip }
  mov ax,80                  {forme la diffrence 80-largeur }
  sub al,cl
  mov byte ptr skip,al       {et la reporte dans skip }

  mov al,byte ptr cpp[di] {charge la largeur de clipping spcifique au plan }
  cmp clip_lt,0           {si pas de clipping  gauche, voyons  droite }
  je @adroite
{sauve en clip_act_lt clip. plan + spcif.}
  mov clipact_lt,ax
  sub Largeur,ax          {rduit le nombre d'octets  copier }
  jmp @clip_rdy           { droite pas de clipping}
@adroite:                 {si pas de clipping  gauche }
  mov clipact_rt,ax       {clipping pour tous les plans en clip_act}
@clip_rdy:
  mov ax,Largeur          {calcule la largeur totale en octets }
  add ax,clipact_rt
  add ax,clipact_lt
  mul clip_up      {multiplie par le nombre de lignes du clipping suprieur }
  add si,ax        {octets non reprsents }
  mov cx,Largeur   {charge la largeur en cx }
  or cl,cl         {largeur 0, plan termin }
  je @planfini

  mov di,ofs            {offset de destination dans l'cran en di}
  mov ah,masqueplan     {rduit le masque de plan aux bits [0..3] }
  and ah,0fh
  mov al,02h            {active le registre 2 du TS (Write Plane Mask)}
  mov dx,3c4h
  out dx,ax
  mov bx,dty                 {initialise le compteur de lignes y }
@lcopy_y:                    {boucle des lignes y }
  add si,clipact_lt          {pointeur source au-del clipping gauche }
  add di,clipact_lt          {idem pour le pointeur de destination }
@lcopy:                      {boucle des pixels }
  lodsb                      {lit un octet }
  or al,al                   {si 0, pas de traitement }
  je @Valeur0
  stosb                      {sinon copie }
@entry:
  loop @lcopy                {suite de la boucle }

  add si,clipact_rt          {aprs ligne complte, clipping droit }

  dec bx                     {incrmente le compteur de lignes }
  je @planfini               {compteur de lignes  = 0, plan suivant }
  add di,skip                {sinon passe en dbut de ligne suivante }
  mov cx,Largeur             {rinitialise le compteur de colonnes }
  jmp @lcopy_y               {retourne dans la boucle des lignes }
@valeur0:                    {couleur du sprite 0 }
  inc di                     {saute l'octet de destination }
  jmp @entry                 {retourne dans la boucle }
@planfini:                   {fin de la boucle des lignes }
  mov ax,Largeur             {calcul la largeur globale en octets }
  add ax,clipact_rt
  add ax,clipact_lt
  mul clip_dn            {multiplie par le nombre de lignes du clipping inf. }
  add si,ax              {octets non rprsents }
  rol masqueplan,1       {masque le plan suivant }
  mov cl,masqueplan      {a-t-on slectionn le plan 0 ?}
  and cx,1               {(bit 1  1), alors}
  add ofs,cx             {incrmente de 1 l'offset de destination (cx bit 1 !)}
  inc plane              {incrmente le numro de plan (indice dans ppp) }
  and plane,3            {rduit de 0  3 }
  dec plane_count        {dj 4 plans copis, on arrte }
  jne @lplane
  pop ds                 {restaure ds, ciao}
End;                     {asm}
End;

Begin
End.
