Program defilement_mode_texte;

Uses ModeXLib,Crt;

Var x,                  {abscisse en pixels}
    x_dir,              {direction horizontale }
    y,                  {ordonne en pixels }
    y_dir:Word;         {direction verticale }

Procedure Wait_In_Display;assembler;
{symtrique de Wait_In_Retrace, attend la gnration
de l'image par le rayon cathodique }
asm
  mov dx,3dah           {Input Status 1}
@wait2:
  in al,dx
  test al,8h
  jnz @wait2            {Image prsente ? -> termin }
End;
Procedure Wait_In_Retrace;assembler;
{attend le retour de balayage vertical, rinitialise
en mme temps le flip-flop de l'ATC en effectuant
un accs en lecture au registre Input Status 1 }
asm
  mov dx,3dah           {Input Status 1}
@wait1:
  in al,dx
  test al,8h
  jz @wait1             {balayage actif ? -> termin }
End;

Procedure FillScreen;
{remplit la mmoire d'cran avec une image de test de 160*50 caractres}
var i:word;
Begin
  For i:=0 to 160*50 do Begin   {boucle des caractres}
    If i mod 10 <> 0 Then       {enregistrer le compteur de colonnes ?}
      mem[$b800:i shl 1]:=      {non, alors '-'}
        Ord('-') Else
      mem[$b800:i shl 1]:=      {oui, numro de colonne dcompt en dizaines }
      ((i mod 160) div 10) mod 10 + Ord('0');
    If i mod 160 = 0 Then   {colonne 0 ? -> enregistre le compteur de lignes }
      mem[$b800:i shl 1]:=(i div 160) mod 10 + Ord('0');
  End;
End;
Procedure V_Pan(n:Byte);assembler;
{excute un panoramique vertical}
asm
  mov dx,3d4h                 {registre 8 du CRTC (Inittial Row Adress)}
  mov al,8
  mov ah,n                    {fixe le dplacement panoramique }
  out dx,ax
End;
Procedure H_Pan(n:Byte);assembler;
{excute un panoramique horizontal  }
asm
  mov dx,3c0h                 {Index/Data Port de l'ATC}
  mov al,13h or 32d           {slectionne le registre 13 h (Horizontal Pixel Paning)}
  out dx,al                   {met  1 le bit 5 (Palette RAM Address Source)}
  mov al,n                    { pour ne pas couper l'cran }
  or al,32d                   {fixe le dplacement panoramique }
  out dx,al
End;

Begin
  TextMode(3);          {mode 3 du BIOS (80*25 caractres, couleur)}
  FillScreen;           {construit l'image de test }
  portw[$3d4]:=$5013;   {double largeur d'cran virtuelle (160 caractres)}
  x:=0;                 {initialise les coordonnes et directions }
  x_dir:=1;
  y:=0;
  y_dir:=1;
  Repeat
    Inc(x,x_dir);       {dplacement horizontal et vertical }
    Inc(y,y_dir);
    If (x<=0) or (x>=80*9) {changement de direction au bord }
      Then x_dir:=-x_dir;
    if (y<=0) or (y>=25*16)
      Then y_dir:=-y_dir;
    Wait_in_Display;     {attend la gnration de l'image }
    SetStart((y div 16 *160)  {recale l'adresse de dbut (dfilement grossier }
      + x div 9);
    Wait_in_Retrace;          {attend le retour de balayage }
    V_Pan(y mod 16);          {panoramique vertical (dfilement fin)}
    H_Pan((x-1) mod 9);       {panoramique horizontal (dfilement fin)}
  Until KeyPressed;           {attend une frappe de touche }
  TextMode(3);                {remet le mode vido normal }
End.
