 data segment
  extrn vscreen:dword           ;pointe sur les donnes du paysage
  extrn x,y: word               ;coordonnes du trapze
  extrn vpage:word              ;page d'cran courante
data ends

code segment
assume cs:code,ds:data

;Variables avec partie dcimale (8 bits infrieurs) :

offst dd 0                      ;offset courant
step dd 0                       ;taille du pixel
row_start dd 0                  ;dbut de la ligne courante
row_step dd 0                   ;distance jusqu' la ligne suivante


z_count dw 0                    ;compteur pour la profondeur
shrink dw 0                     ;correction au bas de l'cran

Ligne dd 0                      ;numro de ligne d'cran courante
vpage_cs dw 0                   ;page d'cran dans le segment de code

.386
public Draw_Voxel
Draw_Voxel proc pascal
;reprsente un paysage dans la page d'cran courante
;lit les donnes dans vscreen  partir de la position (x,y)
  mov ax,vpage                  ;mmorise le numro de la page d'cran
  mov vpage_cs,ax

  push ds
  mov ax,0a000h                 ;charge le segment de destination
  mov es,ax

  mov ax,320                    ;calcule l'offset dans le paysage
  imul y
  add ax,x

  lds si,vscreen                ;prend les donnes dans vscreen 
  add si,ax                     ;tient compte de l'offset
  shl esi,8                     ;conversion en virgule fixe

  mov offst,esi                 ;valeurs initiales pour le pixel ...
  mov row_start,esi             ;... et la ligne

  mov step,100h                 ;facteur d'chelle initial 1
  mov ligne,100*256             ;commence en ligne d'cran 100 
  mov row_step,14040h           ;distance interligne 320,25
  mov shrink,0                  ;pas de correction au dbut
  mov z_count,160               ;nombre de lignes  traiter

 next_y:
  mov eax,Ligne                 ;lit le numro de ligne courant (cran)
  mov ebx,eax                   ;le sauvegarde
  shr eax,8                     ;le convertit en entier
  add eax,50                    ;50 pixels vers le bas
  imul eax,80                   ;convertit en offset
  mov di,ax                     ;sauvegarde comme pointeur de destination 
  cmp di,199*80                 ;a-t-on dpass le bord de l'cran?
  jb normal
  mov di,199*80                 ;oui, on se positionne en dernire ligne

  mov eax,Ligne          ;diffrence par rapport au bord infrieur de l'cran
  shr eax,8
  sub eax,149
  mov shrink,ax                 ;mmorise comme correction

normal:
  add di,vpage_cs               ;ajoute la page d'cran courante

  imul ebx,16500                ;multiplie le numro de ligne par 1,007 
  shr ebx,14                    ;le tout * 16500 / 16384 
  mov Ligne,ebx                 ;on sauvegarde 

mov bp,80                       ;nombre de pixels par ligne
next_x:
  mov esi,offst                 ;charge l'offset du pixel courant
  shr esi,8                     ;le convertit en entier
  xor eax,eax
  mov al,[si]                   ;charge un point du paysage
  mov cx,ax                     ;le sauvegarde

  cmp cx,99                     ;couleur (=hauteur) < 100
  ja fill_bar
  mov ax,99                     ;alors on fixe  99

fill_bar:
  shl ax,5                      ;projection  point de fuite : hauteur * 32
  xor dx,dx
  push bp
  mov bp,z_count                ;divise par la distance
  add bp,50
  idiv bp
  pop bp

  sub ax,shrink                 ;effectue la correction
  jbe suite                     ;si <= 0, ne dessine pas

push di
next_fill:
  mov es:[di],cl                ;enregistre la couleur
  sub di,80                     ;ligne suivante vers le haut
  dec al                        ;dcrmente le compteur
  jne next_fill                 ;on continue ?
  pop di

suite:
  inc di                        ;adresse l'octet suivant  l'cran
  mov esi,step                  ;lit le pas
  add esi,offst                 ;l'ajoute
  mov offst,esi                 ;et renregistre

  dec bp                        ;point suivant
  jne next_x

  mov esi,row_step              ;dplace le dbut de la ligne
  add esi,row_start
  mov row_start,esi
  mov offst,esi                 ;recharge galement l'offset du pixel

  dec step                      ;dcrmente le facteur d'chelle
  dec z_count                   ;et le compteur de ligne 
  jne next_y
  pop ds
  ret
Draw_Voxel endp

code ends
end
